Index: trunk/NEMO/OPA_SRC/iom.F90
===================================================================
--- trunk/NEMO/OPA_SRC/iom.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/iom.F90	(revision 508)
@@ -2,68 +2,62 @@
    !!=====================================================================
    !!                    ***  MODULE  iom ***
-   !!
    !! Input/Output manager :  Library to read input files
-   !!
-   !! Ongoing work : This code is here to help discussions about I/O
-   !!                library in the NEMO system
    !!====================================================================
+   !! History :  9.0  ! 05 12  (J. Belier) Original code
+   !!            9.0  ! 06 02  (S. Masson) Adaptation to NEMO
+   !!--------------------------------------------------------------------
+   !!gm  caution add !DIR nec: improved performance to be checked as well as no result changes
+
    !!--------------------------------------------------------------------
    !!   iom_open       : open a file read only
    !!   iom_close      : close a file or all files opened by iom
-   !!   iom_get        : read a field : interface to several routines
+   !!   iom_get        : read a field (interfaced to several routines)
+   !!   iom_gettime    : read the time axis cdvar in the file               !!gm : never call ??????
    !!   iom_varid      : get the id of a variable in a file
-   !!   iom_get_gblatt : ???
+   !!   iom_rstput     : write a field in a restart file (interfaced to several routines)
    !!--------------------------------------------------------------------
-   !! History :  9.0  ! 05 12  (J. Belier) Original code
-   !!            9.0  ! 06 02  (S. Masson) Adaptation to NEMO
-   !!--------------------------------------------------------------------
-   !! * Modules used
    USE in_out_manager  ! I/O manager
    USE dom_oce         ! ocean space and time domain
-   USE lbclnk          ! ???
-   USE ioipsl          ! ???
+   USE lbclnk          ! lateal boundary condition / mpp exchanges
+   USE ioipsl          ! IOIPSL library
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC iom_open, iom_close, iom_get, iom_varid, iom_get_gblatt
-
-   !! * Interfaces
+   PUBLIC iom_open, iom_close, iom_get, iom_varid, iom_rstput, iom_gettime
+
    INTERFACE iom_get
-      MODULE PROCEDURE iom_get_r_1d, iom_get_r_2d, iom_get_r_3d
+      MODULE PROCEDURE iom_get_r_0d, iom_get_r_1d, iom_get_r_2d, iom_get_r_3d
    END INTERFACE
-
-   !! * Share module variables
-   INTEGER, PARAMETER, PUBLIC ::        &  !:
-      jpdom_data                  = 1,  &  !: ( 1  :jpidta, 1  :jpjdta)
-      jpdom_global                = 2,  &  !: ( 1  :jpiglo, 1  :jpjglo)
-      jpdom_local                 = 3,  &  !: One of the 3 following cases
-      jpdom_local_full            = 4,  &  !: ( 1  :jpi   , 1  :jpi   )
-      jpdom_local_noextra         = 5,  &  !: ( 1  :nlci  , 1  :nlcj  )
-      jpdom_local_noovlap         = 6,  &  !: (nldi:nlei  ,nldj:nlej  )
-      jpdom_unknown               = 7      !: No dimension checking
-
-   !! * Module variables
-   INTEGER, PARAMETER ::    &
-      jpmax_vars    = 50,   &  ! maximum number of variables in one file
-      jpmax_dims    =  5,   &  ! maximum number of dimensions for one variable
-      jpmax_digits  =  5       ! maximum number of digits in the file name to reference the cpu number
- 
+   INTERFACE iom_rstput
+      MODULE PROCEDURE iom_rstput_0d, iom_rstput_1d, iom_rstput_2d, iom_rstput_3d
+   END INTERFACE
+
+   INTEGER, PARAMETER, PUBLIC ::   jpdom_data          = 1   !: ( 1  :jpidta, 1  :jpjdta)
+   INTEGER, PARAMETER, PUBLIC ::   jpdom_global        = 2   !: ( 1  :jpiglo, 1  :jpjglo)
+   INTEGER, PARAMETER, PUBLIC ::   jpdom_local         = 3   !: One of the 3 following cases
+   INTEGER, PARAMETER, PUBLIC ::   jpdom_local_full    = 4   !: ( 1  :jpi   , 1  :jpi   )
+   INTEGER, PARAMETER, PUBLIC ::   jpdom_local_noextra = 5   !: ( 1  :nlci  , 1  :nlcj  )
+   INTEGER, PARAMETER, PUBLIC ::   jpdom_local_noovlap = 6   !: (nldi:nlei  ,nldj:nlej  )
+   INTEGER, PARAMETER, PUBLIC ::   jpdom_unknown       = 7   !: No dimension checking
+
+   INTEGER, PARAMETER ::   jpmax_vars   = 60,   &  ! maximum number of variables in one file
+      &                    jpmax_dims   =  4,   &  ! maximum number of dimensions for one variable
+      &                    jpmax_digits =  5       ! maximum number of digits for the cpu number in the file name
 !$AGRIF_DO_NOT_TREAT
-   INTEGER :: iom_init = 0
-
-   TYPE :: flio_file
+   INTEGER ::   iom_init = 0
+   TYPE    ::   flio_file
       CHARACTER(LEN=240)                        ::   name     ! name of the file
-      INTEGER                                   ::   iopen    ! 1/0 is the file is open/not open
+      INTEGER                                   ::   iopen    ! 1(0) if the file is open(not open)
       INTEGER                                   ::   nvars    ! number of identified varibles in the file
       INTEGER                                   ::   iduld    ! id of the unlimited dimension
       CHARACTER(LEN=16), DIMENSION(jpmax_vars)  ::   cn_var   ! names of the variables
       INTEGER, DIMENSION(jpmax_vars)            ::   ndims    ! number of dimensions of the variables
-      LOGICAL, DIMENSION(jpmax_vars)            ::   luld     ! variable including unlimited dimension
-      INTEGER, DIMENSION(jpmax_dims,jpmax_vars) ::   dimsz    ! size of the dimensions of the variables
+      LOGICAL, DIMENSION(jpmax_vars)            ::   luld     ! variable using the unlimited dimension
+      INTEGER, DIMENSION(jpmax_dims,jpmax_vars) ::   dimsz    ! size of variables dimensions 
       REAL(kind=wp), DIMENSION(jpmax_vars)      ::   scf      ! scale_factor of the variables
       REAL(kind=wp), DIMENSION(jpmax_vars)      ::   ofs      ! add_offset of the variables
    END TYPE flio_file
-   TYPE(flio_file), DIMENSION(flio_max_files)   :: iom_file ! array containing the info for all opened files
+   TYPE(flio_file), DIMENSION(flio_max_files)   ::   iom_file ! array containing the info for all opened files
 !$AGRIF_END_DO_NOT_TREAT
 
@@ -76,72 +70,143 @@
 CONTAINS
 
-   SUBROUTINE iom_open( cdname, knumfl, ldimg )
+   SUBROUTINE iom_open( cdname, knumfl, ldwrt, kdom, ldimg )
       !!---------------------------------------------------------------------
       !!                   ***  SUBROUTINE  iom_open  ***
       !!
       !! ** Purpose :  open an input file read only (return 0 if not found)
-      !!
-      !! ** Method :
-      !!
       !!---------------------------------------------------------------------
-      CHARACTER(len=*), INTENT(in )  ::   cdname   ! File name
-      INTEGER, INTENT(out)           ::   knumfl   ! Identifier of the opened file
-      LOGICAL, INTENT(in ), OPTIONAL ::   ldimg    ! flg to specify that we use dimg format
-
-      CHARACTER(LEN=100) :: clname   ! the name of the file based on cdname [[+clcpu]+clcpu]
-      CHARACTER(LEN=10) :: clsuffix  ! ".nc" or ".dimg"
-      CHARACTER(LEN=10) :: clcpu     ! the cpu number (max jpmax_digits digits)
-      LOGICAL :: llok                ! check the existence 
-      INTEGER :: icnt                ! counter for digits in clcpu (max = jpmax_digits)
+      CHARACTER(len=*), INTENT(in   )           ::   cdname   ! File name
+      INTEGER         , INTENT(  out)           ::   knumfl   ! Identifier of the opened file
+      LOGICAL         , INTENT(in   ), OPTIONAL ::   ldwrt    ! read or write the file?
+      INTEGER         , INTENT(in   ), OPTIONAL ::   kdom     ! Type of domain to be written
+      LOGICAL         , INTENT(in   ), OPTIONAL ::   ldimg    ! use dimg format?
+
+      CHARACTER(LEN=100)    ::   clname    ! the name of the file based on cdname [[+clcpu]+clcpu]
+      CHARACTER(LEN=100)    ::   cltmpn    ! tempory name to store clname (in writting mode)
+      CHARACTER(LEN=10)     ::   clsuffix  ! ".nc" or ".dimg"
+      CHARACTER(LEN=10)     ::   clcpu     ! the cpu number (max jpmax_digits digits)
+      LOGICAL               ::   llok      ! check the existence 
+      LOGICAL               ::   llwrt     ! 
+      INTEGER               ::   icnt      ! counter for digits in clcpu (max = jpmax_digits)
+      INTEGER               ::   iln, ils  ! lengths of character
+      INTEGER               ::   idom      ! type of domain
+      INTEGER               ::   ifliodom  ! model domain identifier (see flio_dom_set)
+      INTEGER, DIMENSION(2) ::   iszl      ! local number of points for x,y dimensions
+      INTEGER, DIMENSION(2) ::   ifst      ! position of first local point for x,y dimensions
+      INTEGER, DIMENSION(2) ::   ilst      ! position of last local point for x,y dimensions
+      INTEGER, DIMENSION(2) ::   ihst      ! start halo size for x,y dimensions
+      INTEGER, DIMENSION(2) ::   ihnd      ! end halo size for x,y dimensions
       !---------------------------------------------------------------------
-
-      ! find the file
+      ! if iom_open is called for the first time: initialize iom_file(:)%iopen to 0
+      ! (could be done when defining iom_file in f95 but not in f90)
+      IF( iom_init == 0 ) THEN
+         iom_file(:)%iopen = 0
+         iom_init = 1
+      ENDIF
+      ! do we read or write the file?
+      ! =============
+      IF( PRESENT(ldwrt) ) THEN   ;   llwrt = ldwrt
+      ELSE                        ;   llwrt = .FALSE.
+      ENDIF
+      ! create the file name by added, if needed, TRIM(Agrif_CFixed()) and TRIM(clsuffix)
       ! =============
       clname   = trim(cdname)
 #if defined key_agrif
       if ( .NOT. Agrif_Root() ) clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
-#endif                
+#endif    
+      ! which suffix should we use?
       clsuffix = ".nc"
-      IF( PRESENT(ldimg) ) THEN
-         IF ( ldimg ) clsuffix = ".dimg"
-      ENDIF
-      !
+      IF( PRESENT(ldimg) ) THEN   ;   IF( ldimg )   clsuffix = ".dimg"   ;   ENDIF
+      ! Add the suffix if needed
+      iln = LEN_TRIM(clname)
+      ils = LEN_TRIM(clsuffix)
+      IF( iln <= ils) clname = clname(1:iln)//TRIM(clsuffix)
+      IF( clname(iln-ils+1:iln) /= TRIM(clsuffix) )   clname = clname(1:iln)//TRIM(clsuffix)
+      cltmpn = clname   ! store this name
+      ! try to find if the file to be opened already exist
       INQUIRE( FILE = clname, EXIST = llok )
-      IF( .NOT.llok ) THEN                         ! try to complete the name with the suffix only
-         clname = TRIM(cdname)//TRIM(clsuffix)
-#if defined key_agrif
-         if ( .NOT. Agrif_Root() ) clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
-#endif                
-         INQUIRE( FILE = clname, EXIST = llok )
-         IF( .NOT.llok ) THEN                      ! try to complete the name with both cpu number and suffix
-            WRITE(clcpu,*) narea-1
-            clcpu  = trim(adjustl(clcpu))
-            clname = trim(cdname)//"_"
-#if defined key_agrif
-            if ( .NOT. Agrif_Root() ) clname = TRIM(Agrif_CFixed())//'_'//TRIM(clname)
-#endif                
-            icnt = 0
-            INQUIRE( FILE = trim(clname)//trim(clcpu)//trim(clsuffix), EXIST = llok ) 
-            DO WHILE( .NOT.llok .AND. icnt < jpmax_digits )   ! we try fifferent formats for the cpu number by adding 0
-               clname = trim(clname)//"0"
-               INQUIRE( FILE = trim(clname)//trim(clcpu)//trim(clsuffix), EXIST = llok )
-               icnt = icnt + 1
-            END DO
-            IF( .NOT.llok ) THEN                   ! no way to find the files...
-               CALL ctl_stop( 'iom_open: file '//trim(clname)//'... not found' )
+      IF( .NOT.llok ) THEN
+         ! we try to add the cpu number to the name
+         WRITE(clcpu,*) narea-1
+         clcpu  = TRIM(ADJUSTL(clcpu))
+         iln = INDEX(clname,TRIM(clsuffix))
+         clname = clname(1:iln-1)//'_'//TRIM(clcpu)//TRIM(clsuffix)
+         icnt = 0
+         INQUIRE( FILE = clname, EXIST = llok ) 
+         ! we try different formats for the cpu number by adding 0
+         DO WHILE( .NOT.llok .AND. icnt < jpmax_digits )
+            clcpu  = "0"//trim(clcpu)
+            clname = clname(1:iln-1)//'_'//TRIM(clcpu)//TRIM(clsuffix)
+            INQUIRE( FILE = clname, EXIST = llok )
+            icnt = icnt + 1
+         END DO
+      ENDIF
+      !
+      IF( llok ) THEN      ! Open the file
+         !                 ! =============
+         IF( llwrt ) THEN 
+            IF(lwp) WRITE(numout,*) '          iom_open ~~~  open existing file: '//TRIM(clname)//' in WRITE mode'
+            CALL flioopfd( TRIM(clname), knumfl, "WRITE" )
+         ELSE
+            IF(lwp) WRITE(numout,*) '          iom_open ~~~  open existing file: '//TRIM(clname)//' in READ mode'
+            CALL flioopfd( TRIM(clname), knumfl )
+         ENDIF
+      ELSE                 ! no way to find the file...
+         !                 ! =======================
+         IF( llwrt ) THEN 
+            ! file opened in write mode
+            ! the file does not exist, we must create it...
+            ! =============
+            llok = .TRUE.
+            ! on which domain must the file be written??
+            ! check the domain definition
+            idom = jpdom_local_noovlap   ! default definition
+            IF( PRESENT(kdom) )   idom = kdom
+            ! create the domain informations
+            ! =============
+            SELECT CASE (idom)
+            CASE (jpdom_local_full)
+               iszl = (/ jpi             , jpj              /)
+               ifst = (/ nimpp           , njmpp            /)
+               ilst = (/ nimpp + jpi - 1 , njmpp + jpj - 1  /)
+               ihst = (/ nldi - 1        , nldj - 1         /)
+               ihnd = (/ jpi - nlei      , jpj - nlej       /)
+            CASE (jpdom_local_noextra)
+               iszl = (/ nlci            , nlcj             /)
+               ifst = (/ nimpp           , njmpp            /)
+               ilst = (/ nimpp + nlci - 1, njmpp + nlcj - 1 /)
+               ihst = (/ nldi - 1        , nldj - 1         /)
+               ihnd = (/ nlci - nlei     , nlcj - nlej      /)
+            CASE (jpdom_local_noovlap)
+               iszl = (/ nlei - nldi + 1 , nlej - nldj + 1  /)
+               ifst = (/ nimpp + nldi - 1, njmpp + nldj - 1 /)
+               ilst = (/ nimpp + nlei - 1, njmpp + nlej - 1 /)
+               ihst = (/ 0               , 0                /)
+               ihnd = (/ 0               , 0                /)
+            CASE DEFAULT
+               llok = .FALSE.
+               CALL ctl_stop( 'iom_open: wrong value of kdom, only jpdom_local* cases are accepted' )
+            END SELECT
+            IF( llok ) THEN
+               CALL flio_dom_set( jpnij, narea-1, (/1, 2/), (/jpiglo, jpjglo/)   &
+                    &                  , iszl, ifst, ilst, ihst, ihnd, 'BOX', ifliodom )        
+               ! create the file
+               ! =============
+               ! Note that fliocrfd may change the value of clname (add the cpu number...)
+               clname = cltmpn   ! get back the file name without the cpu number in it
+               IF(lwp) WRITE(numout,*) '          iom_open ~~~  create new file: '//trim(clname)//' in WRITE mode'
+               CALL fliocrfd( clname, (/'x'    , 'y'    , 'z', 't'/)   &
+                    &               , (/iszl(1), iszl(2), jpk, -1 /)   &
+                    &               , knumfl, ifliodom )
             ENDIF
-            clname = trim(clname)//trim(clcpu)//trim(clsuffix)
+         ELSE
+            ! the file is open for read-only, it must exist...
+            iln = INDEX( cltmpn,TRIM(clsuffix) )
+            CALL ctl_stop( 'iom_open: file '//cltmpn(1:iln-1)//'* not found' )
          ENDIF
       ENDIF
-
-      ! Open the file
+      ! start to fill the information of opened files
       ! =============
       IF( llok ) THEN                         
-         IF (lwp) WRITE(numout,*) 'iom_open ~~~  open file: '//trim(clname)
-         CALL flioopfd( trim(clname), knumfl )
-         IF( iom_init == 0 ) THEN
-            iom_file(:)%iopen = 0
-            iom_init = 1
-         ENDIF
          iom_file(knumfl)%iopen      = 1
          iom_file(knumfl)%name       = TRIM(clname)
@@ -152,8 +217,9 @@
          ! does the file contain time axis (that must be unlimitted) ?
          CALL flioinqf( knumfl, id_uld = iom_file(knumfl)%iduld )
+         IF(lwp) WRITE(numout,*) '                   ---> OK'
       ELSE
-         knumfl = 0
-      ENDIF
-  
+         knumfl = 0      ! return error flag
+      ENDIF
+      !
    END SUBROUTINE iom_open
 
@@ -164,16 +230,12 @@
       !!
       !! ** Purpose : close an input file, or all files opened by iom
-      !!
-      !! ** Method :
-      !!
       !!--------------------------------------------------------------------
-      INTEGER,INTENT(in), OPTIONAL ::   knumfl   ! Identifier of the file to be closed
-      !                                          ! If this argument is not present,
-      !                                          ! all the files opened by iom are closed.
-
-      INTEGER           ::   jf            ! dummy loop indices
-      INTEGER           ::   i_s, i_e      ! temporary integer
+      INTEGER, INTENT(in), OPTIONAL ::   knumfl   ! Identifier of the file to be closed
+      !                                           ! No argument : all the files opened by iom are closed
+
+      INTEGER ::   jf         ! dummy loop indices
+      INTEGER ::   i_s, i_e   ! temporary integer
       !---------------------------------------------------------------------
-
+      !
       IF( PRESENT(knumfl) ) THEN
          i_s = knumfl
@@ -183,8 +245,10 @@
          i_e = flio_max_files
       ENDIF
-      IF ( i_s > 0 ) THEN
+      
+      IF( i_s > 0 ) THEN
          DO jf = i_s, i_e
             IF( iom_file(jf)%iopen > 0 ) THEN
                CALL flioclo( jf )
+               IF(lwp) WRITE(numout,*) '          iom_close, close file: '//TRIM(iom_file(knumfl)%name)//' ok'
                iom_file(jf)%iopen      = 0
                iom_file(jf)%name       = 'NONE'
